import type { TransformOptions } from '@lwc/compiler';
export type Module = any;
export interface HMR_Data_Fetch {
    type: 'fetch';
    data: {
        modulePath: string;
    };
}
export interface HMR_Data_Invalidate {
    type: 'invalidate';
    data: {
        modulePath: string;
    };
}
export interface HMR_Data_Update {
    type: 'update';
    data: {
        modulePath: string;
    }[];
}
export interface HMR_Data_Module_Update {
    type: 'module-update';
    data: {
        modulePath: string;
        src: string;
    }[];
}
export interface HMR_Data_Module_Delete {
    type: 'module-delete';
    data: {
        modulePath: string;
    }[];
}
export interface Auth_Challenge {
    sessionTokenCipher: string;
}
export interface Auth_Response {
    sessionToken: string;
}
export interface HMR_Data_Auth_Challenge {
    type: 'auth-challenge';
    data: Auth_Challenge;
}
export interface HMR_Data_Auth_Response {
    type: 'auth-response';
    data: Auth_Response;
}
export interface HMR_Data_Error {
    type: 'error';
    data: {
        message: string;
    };
}
export interface Module_State {
    modulePath: string;
    hash: string;
    compileOptions: TransformOptions;
}
export interface HMR_Data_Register {
    type: 'register';
    data: {
        modules: Module_State[];
    };
}
export type HMR_Data_Outbound = HMR_Data_Update | HMR_Data_Module_Update | HMR_Data_Module_Delete | HMR_Data_Error | HMR_Data_Auth_Response;
export type HMR_Data_Inbound = HMR_Data_Fetch | HMR_Data_Register | HMR_Data_Invalidate;
export declare function isHmrDataInbound(data: unknown): data is HMR_Data_Inbound;
export declare function isHmrDataOutbound(data: unknown): data is HMR_Data_Outbound;
